#include <iostream>
#include <cstdlib>
#include <time.h>
#include <fstream>
#include <string>
#include <stdlib.h>

#ifdef WIN32
	#include<windows.h>
#endif

using namespace std;



const string separador = "**********************************\n";
const string medio     = "**                              **\n";
const string titulo    = "**   Maths Learning             **\n";
const string subtitulo = "**                    Grender   **\n";
const string saltoG ="\n\n\n\n\n";
const string saltoP = "\n";
const string saltoI     = "               ";
const string idiomaC    = "1. Castellano\n";
const string idiomaI    = "2. Ingles\n";
const string idioma     = "\n Selecciona un idioma: ";
const string EndGame   = "**          GAME OVER           **\n";
const string espacio   = "                  ";
const string Corrects  = "      Correct:  ";
const string Mistakes  = "      Mistakes: ";
const string Score     = "      Score:  ";
const string margenL   = "**    ";
const string margen    ="               **\n";
const string perfil1 = "1. Create profile\n";
const string perfil2 = "2. Load profile\n";
const string nombre = "Insert the name of the profile: ";
const string Sperfil="\nSelect the profile you want to load: ";
const string opcion1 = "1. Play\n";
const string opcion2 = "2. Ranking\n";
const string opcion3 = "3. Instructions\n";
const string opcion4 = "4. Credits\n";
const string opcion5 = "5. Exit\n";
const string opcion = "\nSelect an Option: ";
const string salto = "\n\n\n";
const string correcto = "\n\nCorrect: ";
const string puntosA  = "Points before: ";
const string BonusP   = "Bonus: ";
const string FaseM    = "Fase max: ";
const string PuntosD  = "Points after: ";
const string credito1="Game created by: \n";
const string credito2="   ********                               **               \n";
const string credito3="   **//////**                            /**              \n";
const string credito4="  **      // ******  *****   *******     /**  *****   ******\n";
const string credito5=" /**        //**//* **///**//**///**  ****** **///**//**//*\n";
const string credito6=" /**    *****/** / /******* /**  /** **///**/******* /** / \n";
const string credito7=" //**  ////**/**   /**////  /**  /**/**  /**/**////  /**  \n";
const string credito8="  //********/***   //****** ***  /**//******//******/***  \n";
const string credito9="   //////// ///     ////// ///   //  //////  ////// ///  \n";
const string insM1="1. Basic Features\n";
const string insM2="2. How to play\n";
const string insM3="3. Back to the Menu\n";
const string insM4="1. Normal Mode\n";
const string insM5="2. Be a Hero\n";
const string insM6="3. Stage mode\n";
const string MenuJ ="4. Back to the Menu\n";
const string separadorP = "            **************************\n";
const string medioP     = "            **                      **\n";
const string margenLP   = "            **     ";
const string espacioP   = "                   ";
const string margenRP   = "                                    **\n";
const string score      = "                      Score             ";
const string seconds ="\nGame duration(seconds): ";
const string ficheroperfil="lista_perfiles.txt";
const string insC1="\n This game is an educative one which consists of answering the maximum number\n of questions in a limited period of time which is set before it starts.\n";
const string insC2="\n The normal mode consists of answering the maximum number of questions,every\n correct answer scores 10 points and wrong answers dont count.\n Five correct answers gives you a bonus and the next correct answers score 20\n points. The difficulty of the game will be increased when failing three or\n more questions.The game will be finished when the time is over.\n";
const string insC3="\n 'Be a hero' mode consists of holding the maximum time without reaching the\n first stage (that would mean the end of the game). Every 3 consecutive\n mistakes will decrease a stage and every 5 consecutive correct answers\n will increase a stage.\n";
const string insC4="\n The 'stage' mode is similar to the 'normal' mode but every five questions\n (right or wrong) will increase the stage and the score until stage 5 is\n reached or the time is over.\n";
const string pauseT ="Press enter to continue: ";

// constantes de errores
const string error_file="Process failed opening the file\n";
const string error_perfiles="No profiles created\n";
const string error_tiempo ="Enter a valid time (3600 seconds maximum)\n";
const string error_ranking ="\nNo scores on the ranking\n";

//const enteras
const int K_perfiles=10;



//DECLARACION DE MODULOS
int modo_normal(int segundos);
int modo_fases(int segundos);
int modo_heroe();
int calcula(int num1, int num2, char operador);
int calcula_puntuacion(int tope_fase, int fase, int aciertos, int errores);
void instrucciones();
void credits();
void limpiar_pantalla();
void congelar_pantalla();
void almacenaResultadoNormal(string nombre_perfil, int puntuacion);
void almacenaResultadoHeroe(string nombre_perfil, int puntuacion);
void almacenaResultadoFases(string nombre_perfil, int puntuacion);
void crearperfil(string nombre_perfil);
void abrirperfiles(string Tperfiles[],int &Nperfiles);
void vaciarperfiles(string Tperfiles[]);
void mostrar_ranking(int ranking[],string nombre_perfil,int num_score);
void ranking(string nombre_perfil,char modo);


int main(int argc, char const* argv[])
{
	// PANTALLA DE INICIO
	char seleccion;
	char modo;
	char idiomaV;
	char perfiles;
	int segundos;
	int puntuacion = 0;
	int posicion = 1;
	int num_score=0;
	string Tperfiles[K_perfiles];
	string nombre_perfil = "";
	string fichero;
	int Nperfiles = 0;
	char num_perfil;
	
	// PANTALLA DE PRESENTACION
	cout << saltoG;
	cout << saltoI << separador;
	cout << saltoI << medio;
	cout << saltoI << titulo;
	cout << saltoI << medio;
	cout << saltoI << subtitulo;
	cout << saltoI << medio;
	cout << saltoI << separador;
	congelar_pantalla();



	vaciarperfiles(Tperfiles);

	//PERFIL NUEVO O CARGAR PERFIL
	do{
		do{
            limpiar_pantalla();
			cout << separador;
			cout << medio;
			cout << titulo;
			cout << medio;
			cout << subtitulo;
			cout << medio;
			cout << separador;
			cout << saltoG;
			cout << saltoP;
			cout << perfil1;
			cout << perfil2;
			cout << opcion;
			cin >> perfiles;
			cin.ignore();
		}while((!isdigit(perfiles)) ||((perfiles < '1') || (perfiles > '2')));

		if(perfiles == '1'){
			cout << nombre;
			cin >> nombre_perfil;
			crearperfil(nombre_perfil);
		}else{
			abrirperfiles(Tperfiles,Nperfiles);
			if(Nperfiles != 0){
                do{
                   num_perfil = 0;
                   posicion = 1;
				   cout << saltoP;
				   for(int i=0;i < Nperfiles;i++){
					       cout << posicion << "." << Tperfiles[i] << saltoP;
					       posicion++;
			       }
				   cout << Sperfil;
				   cin >> num_perfil;
				   cin.ignore();
	            }while((!isdigit(num_perfil)) || (num_perfil < '1') || (atoi(&num_perfil) > Nperfiles));
	            num_perfil=atoi(&num_perfil)-1;
				nombre_perfil=Tperfiles[num_perfil];
            }
		}
	}while(nombre_perfil == "");

	do{
		//MENU
		do{
			limpiar_pantalla();
			cout << separador;
			cout << medio;
			cout << titulo;
			cout << medio;
			cout << subtitulo;
			cout << medio;
			cout << separador;
			cout << saltoG;
			cout << opcion1;
			cout << opcion2;
			cout << opcion3;
			cout << opcion4;
			cout << opcion5;
			cout << opcion;
			cin >> seleccion;
			cin.ignore();
			cout << salto;
		}while((!isdigit(seleccion)) || (seleccion < '1') || (seleccion > '6'));

		switch(seleccion)
		{
			case '1':
				do{
					limpiar_pantalla();
					cout << separador;
					cout << medio;
					cout << titulo;
					cout << medio;
					cout << subtitulo;
					cout << medio;
					cout << separador;
					cout << saltoG;
					cout << insM4;
					cout << insM5;
					cout << insM6;
					cout << MenuJ;
					cout << opcion;
					cin >> modo;
					cin.ignore();
				}while((!isdigit(modo)) || (modo < '1') || (modo > '4'));
				if ((modo != '4') && (modo != '2')) {
					// Establecer el Tiempo del Juego

                    

					do{
                       cout << seconds;
					   cin >> segundos;
					   if((segundos < 1) || (segundos > 3600)) cout << error_tiempo;
                   }while((segundos < 1) || (segundos > 3600));
				}if(modo == '1'){
					puntuacion = modo_normal(segundos);
					almacenaResultadoNormal(nombre_perfil, puntuacion);
				}else if (modo == '2') {
                    puntuacion =modo_heroe();
                   	almacenaResultadoHeroe(nombre_perfil, puntuacion);
				}else if  (modo == '3'){
					puntuacion=modo_fases(segundos);
					almacenaResultadoFases(nombre_perfil, puntuacion);
				}

				break;
			case '2':
				do{
					limpiar_pantalla();
					cout << separador;
					cout << medio;
					cout << titulo;
					cout << medio;
					cout << subtitulo;
					cout << medio;
					cout << separador;
					cout << saltoG;
					cout << insM4;
					cout << insM5;
					cout << insM6;
					cout << MenuJ;
					cout << opcion;
					cin >> modo;
					cin.ignore();
				}while((!isdigit(modo)) || (modo < '1') || (modo > '4'));
				if(modo == '1'){
                        ranking(nombre_perfil,modo);
				}else if(modo == '2'){
                      ranking(nombre_perfil,modo);
				}else if(modo == '3'){
                      ranking(nombre_perfil,modo);
				}
				break;
			case '3':
				instrucciones();
				break;
			case '4':
				limpiar_pantalla();
				credits();
				break;
		}
	}while(seleccion != '5');
	return(0);

}


// MODULOS DEL PROGRAMA

//VACIAR PERFILES
//*********************************************************************************************
void vaciarperfiles(string Tperfiles[]){
	for(int i= 0; i < K_perfiles; i++){
		Tperfiles[i]="";
	}
}
//INSTRUCCIONES
//*********************************************************************************************
void instrucciones()
{
	char seleccion;
	do{
        do{
    		limpiar_pantalla();
    		cout << separador;
    		cout << medio;
    		cout << titulo;
    		cout << medio;
    		cout << subtitulo;
    		cout << medio;
    		cout << separador;
    		cout << saltoG;
    		cout << insM1;
    		cout << insM2;
    		cout << insM3;
    		cout << saltoP << opcion;
    		cin >> seleccion;
    		cin.ignore();
        }while((!isdigit(seleccion)) || (seleccion < '1') || (seleccion > '4'));
		switch(seleccion)
		{
			case '1':
				cout << insC1;
				cout << saltoP;
				cout << pauseT;
				cin.get();
				limpiar_pantalla();
				break;
			case '2':
				do{
                    do{
    					limpiar_pantalla();
    					cout << separador;
    					cout << medio;
    					cout << titulo;
    					cout << medio;
    					cout << subtitulo;
    					cout << medio;
    					cout << separador;
    					cout << saltoG;
    					cout <<insM4;
    					cout << insM5;
    					cout <<insM6;
    					cout << MenuJ;
    					cout << saltoP << opcion;
    					cin >> seleccion;
    					cin.ignore();
                    }while((!isdigit(seleccion)) || (seleccion < '1') || (seleccion > '4'));
					switch(seleccion)
					{
						case '1':
							cout << insC2;
							cout << saltoP;
							cout << pauseT;
							cin.get();
							limpiar_pantalla();
							break;
						case '2':
							cout << insC3;
							cout << saltoP;
							cout << pauseT;
							cin.get();
							limpiar_pantalla();
							break;
						case '3':
							cout << insC4;
							cout << saltoP;
							cout << pauseT;
							cin.get();
							limpiar_pantalla();
					}
				}while(seleccion != '4');
				seleccion=' ';
				break;
		}
	}while(seleccion != '3');
}

// LIMPIAR PANTALLA
//*********************************************************************************************
void limpiar_pantalla() {
	#ifdef WIN32
	std::system("cls");
	#else
	std::system("clear");
	#endif
}

// CONGELAR PANTALLA
//*********************************************************************************************
void congelar_pantalla() {
	#ifdef WIN32
	Sleep(3000);
	#else
	sleep(3);
	#endif
}

// MODO NORMAL
//**************************************************************************************
int modo_normal(int segundos)
{
	int numero1 = 0;
	int numero2 = 0;
	int posicion = 0;
	int fase = 1;
	int n = 1;
	char operador = ' ';
	int resultado = 0;
	int puntuacionF = 0;
	int valor = 0;
	int aciertos = 0;
	int errores = 0;
	int erroresB = 0;
	int iniRand = 1;
	int finRand = 8;
	float tiempo = 0;
	int bonus = 0;
	char operadores [4] = {'+','-','*','/'};
	char operadoresD[2] = {'*','/'};
	char operadoresF[2] = {'+','-'};
	time_t ini_time;
	time_t fin_time;

	// Obtener un random aleatorio utilizando la fecha y la hora.
	srand (time(NULL));

	// Iniciar Temporizador
	ini_time = time(NULL);
	do {
		// Se utilizan las variables iniRand y finRand para establecer el n?ro de cifras en funci?de la Fase.
		numero1 = iniRand + rand()%finRand;
		numero2 = iniRand + rand()%finRand;


		if(fase >= 2){
			posicion = rand()%2;
			if(bonus > 3) operador = operadoresD[posicion];
			else operador=operadoresF[posicion];
		}else {
			posicion = rand()%4;
			operador = operadores[posicion];
		}
		   resultado = calcula(numero1, numero2, operador);
		   cout << saltoP <<"      " <<  numero1 << " " << operador << " " << numero2 << " = ";
		   cin >> valor;
		   cout  << saltoP << separador;
		   fin_time = time(NULL);
		   tiempo = fin_time - ini_time;
		// Si la ultima respuesta fue un Acierto y entr?n el tiempo, se contabiliza.
		if ((resultado == valor)&&(tiempo < segundos)) {
			//Si se aciertan 5 preguntas seguidas se obtiene un bonus
			aciertos = aciertos + n;
			bonus++;
			erroresB = 0;

			if(bonus == 5) {
				n++;
				bonus = 0;
				finRand = finRand + (81 * iniRand);
				iniRand = iniRand * 10;
				fase = fase + 1;
			}
		}else {
			//Aumentan los errores y si alcanza a 3 consecutivos se pierde el bonus y se baja de fase(a no ser que est?n la fase 1)
			errores++;
			erroresB++;
			bonus = 0;
			if(erroresB == 3){
				n=1;
				iniRand = iniRand / 10;
				finRand = finRand / 10;
				erroresB = 0;
				if(fase != 1) fase = fase - 1;
			}
		}
	}while ((fase < 5)&&(tiempo < segundos));
	//Puntuacion final
	puntuacionF = aciertos * 5;

	cout << espacio << separador;
	cout << espacio << medio;
	cout << espacio << Corrects << aciertos << saltoP;
	cout << espacio << Mistakes << errores << saltoP;
	cout << espacio << Score << puntuacionF << saltoP;
	cout << espacio << medio;
	cout << espacio << separador;

	cout << pauseT;
	cin.ignore();
	cin.get();

	return(puntuacionF);
}


// MODO FASES
//***************************************************************************************
/*	Varias fases:
		Fase 1:	(0 - 5)	Operaciones - N?ros de 1 cifras
		Fase 2:	(6 - 15)	Operaciones - N?ros de 2 cifras
		Fase 3:	(16 - 30)	Operaciones - N?ros de 3 cifras
		Fase 4:	(31 - 50)	Operaciones - N?ros de 4 cifras
		Fase 5:	(51 - 75)	Operaciones - N?ros de 5 cifras
		Fase 6:	(76 - 105)	Operaciones - N?ros de 6 cifras
		Fase 7:	(106 - 140)	Operaciones - N?ros de 7 cifras
*/
/*************************************************************************************/
int modo_fases(int segundos) {
	int numero1 = 0;
	int numero2 = 0;
	int posicion = 0;
	int fase = 1;
	int tope_fase = 0;
	char operador = ' ';
	int resultado = 0;
	int valor = 0;
	int aciertos = 0;
	int aciertosF = 0;
	int errores = 0;
	int erroresF = 0;
	int iniRand = 1;
	int finRand = 8;
	int tiempo = 0;
	int puntuacionF = 0;
	char operadores [4] = {'+','-','*','/'};
	time_t ini_time;
	time_t fin_time;

	// Obtener un random aleatorio utilizando la fecha y la hora.
	srand (time(NULL));

	// Iniciar Temporizador
	ini_time = time(NULL);
	do {
		tope_fase = fase * 5 + tope_fase;
		for (int i = 0; ((i < tope_fase)&&(tiempo < segundos)); i++) {
			// Se utilizan las variables iniRand y finRand para establecer el n?ro de cifras en funci?de la Fase.
			numero1 = iniRand + rand()%finRand;
			numero2 = iniRand + rand()%finRand;

			posicion = rand()%4;
			operador = operadores[posicion];
			resultado = calcula(numero1, numero2, operador);
			cout << saltoP << "       " << numero1 << " " << operador << " " << numero2 << " = ";
			cin >> valor;
			cout <<  saltoP << separador;
			fin_time = time(NULL);
			tiempo = (fin_time - ini_time);

			// Si la ?ima respuesta fue un Acierto y entr?n el tiempo, se contabiliza.
			if ((resultado == valor)&&(tiempo < segundos)) aciertos = aciertos + 1;
			else errores = errores + 1;
		}
		// Antes de cambiar de Fase, calculamos la Puntuaci?
		puntuacionF = puntuacionF + calcula_puntuacion(tope_fase, fase, aciertos, errores);
		aciertosF= aciertosF + aciertos;
		erroresF = erroresF + errores;
		aciertos = 0;
		errores = 0;
		if (tiempo < segundos) {
			finRand = finRand + (81 * iniRand);
			iniRand = iniRand * 10;
			fase = fase + 1;
		}
	}while ((fase < 7)&&(tiempo < segundos));

	cout << espacio << separador;
	cout << espacio << medio;
	cout << espacio << Corrects << aciertosF << saltoP;
	cout << espacio << Mistakes << erroresF << saltoP;
	cout << espacio << Score << puntuacionF << saltoP;
	cout << espacio << medio;
	cout << espacio << separador;
	cout << pauseT;
	cin.ignore();
	cin.get();

	return(puntuacionF);
}

// MODO HEROE
//*************************************************************************************
int modo_heroe() {

	int numero1 = 0;
	int numero2 = 0;
	int posicion = 0;
	int fase = 5;
	int n = 5;
	char operador = ' ';
	int resultado = 0;
	int puntuacionF = 0;
	int valor = 0;
	int aciertos = 0;
	int errores = 0;
	int erroresB = 0;
	int iniRand = 10000;
	int finRand = 81000;
	int bonus = 0;
	char operadores [4] = {'+','-','*','/'};
	char operadoresD[2] = {'*','/'};
	char operadoresF[2] = {'+','-'};
	// Obtener un random aleatorio utilizando la fecha y la hora.
	srand (time(NULL));

	// Iniciar Temporizador
	do {
		// Se utilizan las variables iniRand y finRand para establecer el n?ro de cifras en funci?de la Fase.
		numero1 = iniRand + rand()%finRand;
		numero2 = iniRand + rand()%finRand;

		if(fase >= 2){
			posicion = rand()%2;
			if(bonus > 3) operador = operadoresD[posicion];
			else operador=operadoresF[posicion];
		}else {
			posicion = rand()%4;
			operador = operadores[posicion];
		}
		resultado = calcula(numero1, numero2, operador);
		cout << saltoP  <<"      " <<  numero1 << " " << operador << " " << numero2 << " = ";
		cin >> valor;
		cout  << saltoP << separador;


		// Si la ?ima respuesta fue un Acierto y entr?n el tiempo, se contabiliza.
		if (resultado == valor) {
			//Si se aciertan 5 preguntas seguidas se obtiene un bonus
			aciertos = aciertos + n;
			bonus++;
			erroresB = 0;

			if((bonus == 5) && (fase != 5)) {
				n++;
				bonus = 0;
				finRand =finRand + 81 * iniRand;
				iniRand = iniRand * 10;

				fase = fase + 1;
			}
		}else {
			//Aumentan los errores y si alcanza a 3 consecutivos se pierde el bonus y se baja de fase(a no ser que est?n la fase 1)
			errores++;
			erroresB++;
			bonus = 0;
			if(erroresB == 3){
				n--;
				iniRand = iniRand / 10;
				finRand = finRand / 10;
				fase = fase - 1;
				erroresB = 0;
			}
		}
	}while (fase != 1);
	//Puntuacion final
	puntuacionF = aciertos * 5;

	cout << espacio << separador;
	cout << espacio << medio;
	cout << espacio << Corrects << aciertos << saltoP;
	cout << espacio << Mistakes << errores << saltoP;
	cout << espacio << Score << puntuacionF << saltoP;
	cout << espacio << medio;
	cout << espacio << separador;

	cout << pauseT;
	cin.ignore();
	cin.get();

	return(puntuacionF);
}

// CALCULA
//*************************************************************************************
int calcula(int num1, int num2, char operador) {
	switch (operador) {
			case '+':
				return num1 + num2;
				break;
			case '-':
				return num1 - num2;
				break;
			case '*':
				return num1 * num2;
				break;
			case '/':
				return num1 / num2;
				break;
	}
	return -1;
}

// CALCULA PUNTUACION
//*************************************************************************************
int calcula_puntuacion(int tope_fase, int fase, int aciertos, int errores) {
	int puntos = 0;
	int bonus = 0;
	puntos = aciertos * (fase * 10);
	cout << correcto << aciertos << saltoP;
	cout << puntosA << puntos << saltoP;
	cout << FaseM << tope_fase << saltoP;
	if (aciertos == tope_fase) bonus = (fase * 100);
	else if (errores >= 3) bonus = 0;
	puntos = puntos + bonus;
	cout << BonusP << bonus << saltoP;
	cout << PuntosD << puntos << saltoP << saltoP;
	return puntos;
}


// ALMACENA RESULTADO DE NORMAL EN FICHERO
//*************************************************************************************
void almacenaResultadoNormal(string nombre_perfil, int puntuacion) {
	fstream fichero;

	string ficheropointsN = "";
	ficheropointsN.append(nombre_perfil.begin(),nombre_perfil.end());
	ficheropointsN.append("_pointsN.txt");

	// Al abrir el fichero con app, directamente se sit?al final y a?e la nueva Puntuaci?
	fichero.open(ficheropointsN.c_str(),fstream::out | fstream::app);
	if(fichero.is_open()) {
		// Escribir Nueva Puntuaci?
		fichero << puntuacion << "\n";
		fichero.close();
	}else cout << error_file;
}
// ALMACENA RESULTADO DE HEROE EN FICHERO
//*************************************************************************************
void almacenaResultadoHeroe(string nombre_perfil, int puntuacion) {
	fstream fichero;

	string ficheropointsH = "";
	ficheropointsH.append(nombre_perfil.begin(),nombre_perfil.end());
	ficheropointsH.append("_pointsH.txt");

	// Al abrir el fichero con app, directamente se sit?al final y a?e la nueva Puntuaci?
	fichero.open(ficheropointsH.c_str(),fstream::out | fstream::app);
	if(fichero.is_open()) {
		// Escribir Nueva Puntuaci?
		fichero << puntuacion << "\n";
		fichero.close();
	}else cout << error_file;
}
// ALMACENA RESULTADO DE FASES EN FICHERO
//*************************************************************************************
void almacenaResultadoFases(string nombre_perfil, int puntuacion) {
	fstream fichero;

	string ficheropointsF = "";
	ficheropointsF.append(nombre_perfil.begin(),nombre_perfil.end());
	ficheropointsF.append("_pointsF.txt");

	// Al abrir el fichero con app, directamente se sit?al final y a?e la nueva Puntuaci?
	fichero.open(ficheropointsF.c_str(),fstream::out | fstream::app);
	if(fichero.is_open()) {
		// Escribir Nueva Puntuaci?
		fichero << puntuacion << "\n";
		fichero.close();
	}else cout << error_file;
}

// ALMACENA NOMBRE DE PERFIL EN FICHERO
//*************************************************************************************
void crearperfil(string nombre_perfil){
	fstream fichero;
	string ficheropointsN = "";
	ficheropointsN.append(nombre_perfil.begin(),nombre_perfil.end());
	ficheropointsN.append("_pointsN.txt");
	string ficheropointsH = "";
	ficheropointsH.append(nombre_perfil.begin(),nombre_perfil.end());
	ficheropointsH.append("_pointsH.txt");
	string ficheropointsF = "";
	ficheropointsF.append(nombre_perfil.begin(),nombre_perfil.end());
	ficheropointsF.append("_pointsF.txt");

	// Al abrir el fichero con app, directamente se sit?al final y a?e la nueva Puntuaci?
	fichero.open(ficheroperfil.c_str(),fstream::out | fstream::app);
	if(fichero.is_open()) {
		// Escribir Nombre
		fichero << nombre_perfil << "\n";
		fichero.close();
	}else cout << error_file;

	fichero.open(ficheropointsN.c_str(),fstream::out | fstream::app);
	fichero.close();
	fichero.open(ficheropointsH.c_str(),fstream::out | fstream::app);
	fichero.close();
	fichero.open(ficheropointsF.c_str(),fstream::out | fstream::app);
	fichero.close();
}

// LEER LISTADEPERFILES
//*************************************************************************************
void abrirperfiles(string Tperfiles[],int &Nperfiles) {
	fstream fichero;
	string linea;

	// Al abrir el fichero con app, directamente se sit?al final y a?e la nueva Puntuaci?
	fichero.open(ficheroperfil.c_str(),ios::in);
	if(fichero.is_open()) {
		//getline(fichero,linea);
		// Recorrer Fichero Buscando la mejor Puntuaci?
		linea = "";
		getline(fichero,linea);
		while ((!fichero.eof()) && (linea.length()!= 0)) {
			// Lee un caracter del archivo
			Tperfiles[Nperfiles]=linea;
			Nperfiles++;
			linea = "";
			getline(fichero,linea);
		}
		fichero.close();
	}else {
		cout << error_perfiles;
		cout << pauseT;
		cin.get();
    }
}


//RANKING
//*************************************************************************************
void ranking(string nombre_perfil,char modo)
{
	fstream fichero;
	string linea = "";
	int ranking[K_perfiles];
	int pos = 0;
	int num_score = 0;
	int n=0;
	bool encontrado = false;
	//vaciar
	for(int i=0; i < K_perfiles; i++) 	ranking[i] = 0;

	//coger todas las puntuaciones del fichero
	if(modo == '1'){
    	string ficheropointsN = "";
    	ficheropointsN.append(nombre_perfil.begin(),nombre_perfil.end());
    	ficheropointsN.append("_pointsN.txt");
	    fichero.open(ficheropointsN.c_str(),ios::in);
    }else if(modo =='2'){
   	    string ficheropointsH = "";
    	ficheropointsH.append(nombre_perfil.begin(),nombre_perfil.end());
    	ficheropointsH.append("_pointsH.txt");
	    fichero.open(ficheropointsH.c_str(),ios::in);
     }else{
    	string ficheropointsF = "";
    	ficheropointsF.append(nombre_perfil.begin(),nombre_perfil.end());
    	ficheropointsF.append("_pointsF.txt");
	    fichero.open(ficheropointsF.c_str(),ios::in);
     }
			if(fichero.is_open()) {
				linea = "";
				getline(fichero,linea);
				while ((!fichero.eof()) && (linea.length()!= 0)) {
						//averiguar la posicion
				        encontrado = false;
				        pos = 0;
						while((pos < K_perfiles) && (!encontrado)) {
							if(ranking[pos] < (atoi( linea.c_str() ))) encontrado=true;
							else pos++;
						}

						//mientras la posicion sea menor que el numero de puntuaciones
						if(encontrado){
                           if(num_score != 0){
        						if(pos < num_score) {
        							int i = 0;
        							// Si hay 10 puntuaciones anotadas, se machaca la ltima y se desplaza el resto hasta pos.
                                    if (num_score == K_perfiles) i = num_score-1;
        							else i = num_score;
        							while((i != pos)&&(i < K_perfiles)){
        								ranking[i] = ranking[i - 1]; //desplazar
        								i--;
        							}
        						}
                            }
 					        ranking[pos] = atoi( linea.c_str() );
					        if (num_score < K_perfiles) num_score++;
    					}
					linea = "";
					getline(fichero,linea);
				}
				fichero.close();
			}else cout << error_file;


	mostrar_ranking(ranking,nombre_perfil, num_score);
}

//MOSTRAR_RANKING
//*************************************************************************************
void mostrar_ranking(int ranking[],string nombre_perfil, int num_score)
{
	int posicion = 1;
	cout << separadorP << medioP << espacioP << nombre_perfil << saltoP  << medioP << separadorP;
	if(num_score !=0){
    	for(int i = 0; i < num_score; i++) {
    		cout << posicion << "." << " " << ranking[i] << "\n";
    		posicion++;
    	}
     }else cout << error_ranking;
	cout << saltoP << pauseT;
	cin.get();
}
// CREDITS
//*************************************************************************************
void credits() {
	cout << credito1;
	cout << salto;
	cout << credito2;
	cout << credito3;
	cout << credito4;
	cout << credito5;
	cout << credito6;
	cout << credito7;
	cout << credito8;
	cout << credito9;
	cout << salto;

	cout << pauseT;;
	cin.get();
}

